package com.brainysoftware.batik;

import java.io.IOException;
import java.text.DecimalFormat;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class ControllerServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	public void doPost(HttpServletRequest req, HttpServletResponse resp) 
			throws IOException, ServletException {
		// Get the 'action' parameter from the request
		String action = req.getParameter("action");
		
		// Execute appropriate action depending on the parameter value
		if (action.equals("nameSubmit")) { // If the name was submitted
			String name = req.getParameter("name");
			if ("".equals(name)) name = "Anonymous";
			
			// Create the check number
			int number = (int)(Math.random() * 100000000);
			DecimalFormat df = new DecimalFormat("00000000");
			String checkNumber = df.format(number);
			
			// Put both the name and the number into session
			HttpSession session = req.getSession();
			session.setAttribute("name", name);
			session.setAttribute("number", checkNumber);
			
			// Dispatch the request to the showInfo.jsp page
			RequestDispatcher rd = req.getRequestDispatcher("showInfo.jsp");
			rd.forward(req, resp);
		}
		if (action.equals("codeInput")) { // If the check number was submitted
			
			// Get the number submitted by user from the request
			String codeInput = req.getParameter("codeInput").trim();
			
			// Get the check number from the session 
			HttpSession session = req.getSession();
			String code = (String) session.getAttribute("number");
			
			String nextPage = "";
			
			// If the submitted number is correct, 
			// dispatch to the hiddenPage.jsp
			if (codeInput.equals(code)) {
				nextPage = "hiddenPage.jsp";
			}
			// Otherwise, return to the showInfo.jsp and set the error message 
			else { 
				nextPage = "showInfo.jsp";
				req.setAttribute("errorMessage", "Your input was wrong. Please try again.");
			}
			RequestDispatcher rd = req.getRequestDispatcher(nextPage);	
			rd.forward(req, resp);
		}
	}
}
